<script>
import list from '../quatro-words.json'

const lengths = ['2','3','4']

export default {
  name: 'ElgQuatro',
  props: {
    number: { required: false, type: Number, default: null },
    length: { required: false, type: String, default: null, validator: v => lengths.includes(v) },
  },
  data () {
    return {
      first: null,
      last: null,
      placeholder: null,
    }
  },
  methods: {
    generate () {
      let keys = Object.keys(list)
      if(this.length) { keys = keys.filter(k => k.length === Number(this.length))}

      const index = Math.floor(Math.random() * keys.length)
      const key = keys[index]


      const firstIndex = Math.floor(Math.random() * list[key].length)
      this.first = list[key][firstIndex]

      let secondIndex = Math.floor(Math.random() * list[key].length)
      while (secondIndex === firstIndex) {
        secondIndex = Math.floor(Math.random() * list[key].length)
      }
      this.last = list[key][secondIndex]

      this.placeholder = Array(key.length).fill('_').join(' ')

      this.$emit('selected', {
        number: this.number,
        hidden: key,
        parts: [this.first, this.last],
      })
    },
  },
  created () {this.generate()},
}
</script>

<template>
  <div v-if="first && last" class="elg-quatro">
    <div class="elg-quatro__w1_1">{{ first[0] }}</div>
    <div class="elg-quatro__w1_2">{{ first[1] }}</div>
    <div class="elg-quatro__w2_1">{{ last[0] }}</div>
    <div class="elg-quatro__w2_2">{{ last[1] }}</div>
    <div class="elg-quatro__wrapper">
      <div class="elg-quatro__placeholder">{{ placeholder }}</div>
    </div>
    <div class="elg-quatro__number" v-if="number">{{ number }}</div>
  </div>
</template>

<style lang="scss" scoped>
.elg-quatro {
  $gap: 0.5em;
  $border-color: #888;

  display: flex;
  position: relative;
  text-align: center;
  align-items: stretch;
  height: 100%;
  width: 100%;
  padding: 10%;
  text-transform: uppercase;

  &__wrapper {
    border: 1px solid $border-color;
    border-radius: 50%;
    width: 100%;
    height: 0;
    padding-top: 100%;
  }

  &__placeholder {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -100%);
  }

  &__w1_1,
  &__w1_2,
  &__w2_1,
  &__w2_2 {
    padding: 0 $gap;
    border: 1px solid $border-color;
    border-radius: 0.5em;
    position: absolute;
    background: white;
    display: flex;
    align-items: center;
    gap: $gap;
    font-weight: bold;
  }

  &__w1_1::after,
  &__w2_1::after,
  &__w1_2::before,
  &__w2_2::before {
    content: '▸';
    transform-origin: center;
  }

  &__w1_1 {
    left: 0;
    top: 20%;

    &::after { transform: rotate(45deg); }
  }

  &__w1_2 {
    bottom: calc(20% + 1em);
    right: 0;
    &::before { transform: rotate(-135deg); }
  }

  &__w2_1 {
    bottom: calc(20% + 1em);
    left: 0;
    &::after { transform: rotate(-45deg); }
  }

  &__w2_2 {
    right: 0;
    top: 20%;
    &::before { transform: rotate(135deg); }
  }

  &__number {
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, -50%);
    display: inline-block;
    font-size: 0.8em;
    font-family: monospace;
    padding: 0 3px;
    border: 1px solid $border-color;
    background: white;
  }
}
</style>
